/**************************************************************************************************

 * t@C : JPKIServiceAPI.h

 * @\Tv   : lF؃T[rX`o

 * Copyright (C) 2016

 * Japan Agency for Local Authority Information Systems All Rights Reserved.

**************************************************************************************************/
#ifndef __JPKISERVICEAPI_H__
#define __JPKISERVICEAPI_H__

#include <windows.h>

#ifdef __cplusplus
  extern "C"
  {
#endif

/* JPKICertViewDialog֐AJPKIGetBasicData֐ʂ̖߂l */
#define JPKI_USER_TRUE									 0
#define JPKI_USER_FALSE_INVALID_PARAM					-101
#define JPKI_USER_FALSE_MEMORY							-102
#define JPKI_USER_FALSE_DECODE_CERT						-103
#define JPKI_USER_FALSE_OTHER							-104

/* JPKICertViewDialog֐̖߂l */
#define JPKI_USER_FALSE_SHOW_VIEWER						-105

/* JPKIGetCardType֐̖߂l */
#define JPKI_USER_FALSE_ICCARD_NOT_READY				-106

/* JPKICertValid֐̖߂l */
#define JPKI_CVS_OK										 0
#define JPKI_CVS_NG										-1
#define JPKI_CVS_FALSE_CL_MEMORY						-2
#define JPKI_CVS_FALSE_CL_INVALID_PARAM					-3
#define JPKI_CVS_FALSE_CL_OTHER							-4
#define JPKI_CVS_FALSE_CL_CREATE_REQUEST				-5
#define JPKI_CVS_FALSE_CL_HTTP							-6
#define JPKI_CVS_FALSE_SV_DECODE						-7
#define JPKI_CVS_FALSE_SV_RESPONSE_EXCEPTION			-8
#define JPKI_CVS_FALSE_SV_SIGN_VERIFY_SIGNATURE			-9
#define JPKI_CVS_FALSE_SV_NONCE							-10
#define JPKI_CVS_FALSE_SV_CERT_VERYFY					-11
#define JPKI_CVS_FALSE_SV_ANALYZE						-12
#define JPKI_CVS_FALSE_CL_CVSURL						-13
#define JPKI_CVS_FALSE_CL_GETCERT						-14

/* ؖ،ʃR[hcertPathStatus */
#define JPKI_CVS_GOOD									0
#define JPKI_CVS_INTERNAL_PATH_CONSTRUCTION_ERROR		101
#define JPKI_CVS_SIGNATURE_VERIFICATION_FAILURE			202
#define JPKI_CVS_ONE_OR_MORE_CERTIFICATES_ARE_REVOKED	203
#define JPKI_CVS_POLICY_MAPPING_ERROR					204
#define JPKI_CVS_CONSTRAINTS_ERROR						205
#define JPKI_CVS_CERTSTATUS_OF_OCSP_RESPONSE_IS_UNKNOWN	206
// 2013/7/31 Add Start #02050004
#define JPKI_CVS_REJECTED_BY_ALGORITHM_EE				301
#define JPKI_CVS_REJECTED_BY_ALGORITHM_CA				302
// 2013/7/31 Add End #02050004
#define JPKI_CVS_REJECTED_A_REQUEST						901
#define JPKI_CVS_VALIDATION_TIMEOUT						902

/* OCSPX|XXe[^XresponseStatus */
#define JPKI_CVS_RESSTATUS_SUCCESSFUL					0
#define JPKI_CVS_RESSTATUS_MALFORMEDREQUEST				1
#define JPKI_CVS_RESSTATUS_INTERNALERROR				2
#define JPKI_CVS_RESSTATUS_TRYLATER						3
#define JPKI_CVS_RESSTATUS_SIGREQUIRED					5
#define JPKI_CVS_RESSTATUS_UNAUTHORIZED					6

/* IC߂l */
#define JPKI_CONFIRM_OK                200
#define JPKI_SERVER_VERIFY_ERROR       600
#define JPKI_SERVER_APPLY_ERROR        601
#define JPKI_SERVER_EXPIRED_ERROR      602
#define JPKI_SERVER_DATA_ERROR         603
#define JPKI_SERVER_ISSUER_ERROR       604
#define JPKI_SERVER_VALIDITY_ERROR     605
#define JPKI_SERVER_OCSP_ERROR         606
#define JPKI_SERVER_REVOKED_ERROR      607
#define JPKI_SERVER_APPLYED_ERROR      608
#define JPKI_SERVER_DB_ERROR           609
#define JPKI_SERVER_PW_LOCK_ERROR      610
#define JPKI_SERVER_JAM_ERROR          611
#define JPKI_SERVER_OTHER_ERROR        612
#define JPKI_SERVER_HOLD_ERROR         613
#define JPKI_SERVER_CERT_UNMATCH_ERROR 622
#define JPKI_CLIENT_LOGIN_CANCEL       700
#define JPKI_CLIENT_NOMEMORY           701
#define JPKI_CLIENT_UNEXPECTED_ERR     702
#define JPKI_CLIENT_ICCARD_BLOCKED     703
#define JPKI_CLIENT_ICCARD_NOT_READY   704
#define JPKI_CLIENT_FALSE_DECODE_CERT  705
#define JPKI_CLIENT_ONLINE_TIME        706
#define JPKI_CLIENT_HTTP_NOT_ACCESS    707
#define JPKI_CLIENT_EXPIRED_ERROR      708
#define JPKI_CLIENT_NOT_YET_VALID      709
#define JPKI_CLIENT_UNKNOWN_CARD       710

/* JPKIGetCardType֐AJ[h */
#define JPKI_CARD_ID_UNKNOWN							0	/* s */
#define JPKI_CARD_ID_JYUKI								1	/* ZJ[h */
#define JPKI_CARD_ID_BANGO								2	/* lԍJ[h */

/* ICJ[hʏ TOKEN̒ */
#define JPKI_TOKENINFO_LABEL			"JPKIAPICCTOKEN                  "
#define JPKI_TOKENINFO_BANGO_LABEL		"JPKIAPICCTOKEN2                 "
#define JPKI_TOKENINFO_LENGTH			32					/* TOKEN񕶎 */

/* dqؖ */
typedef struct _JPKI_CertBinaryData {
    unsigned long len;						/* dqؖf[^ */
    unsigned char *data;					/* dqؖf[^̊i[|C^ */
} JPKI_CertBinaryData;  

/* {4 */
typedef struct _JPKI_BasicData {
    wchar_t *name;							/*  */
    wchar_t *address;						/* Z */
    char *gender;							/*  */
    char *dateOfBirth;						/* N */
    char *substituteCharacterOfName;		/* ֕̎gpij */
    char *substituteCharacterOfAddress;		/* ֕̎gpiZj */
} JPKI_BasicData;  

/* ICJ[hʏ */
typedef struct _JPKI_CardType {
	int id;													/* J[h */
	unsigned char tokenInfo[JPKI_TOKENINFO_LENGTH];			/* TOKEN̊i[ */
} JPKI_CardType;

/* ؖ\@\ */
int WINAPI JPKICertViewDialog(
    JPKI_CertBinaryData *
    );

/* {4擾@\ */
int WINAPI JPKIGetBasicData(
    JPKI_CertBinaryData *,
    JPKI_BasicData *
    );

/* Eؖ؋@\ */
int WINAPI JPKICertValid(
    JPKI_CertBinaryData *,
    int *, 
    int *
    );

/* {4擾@\̖߂l폜 */
int WINAPI JPKIFreeBasicData(
    JPKI_BasicData *
    );

/* Ȃ̓dqؖ(pҏؖ)̗LmF */
int WINAPI JPKIConfirm(
    JPKI_CertBinaryData *
    );

/* J[hʔ */
int WINAPI JPKIGetCardType(
	JPKI_CardType *
	);

#ifdef __cplusplus
  }
#endif

#endif	/* __JPKISERVICEAPI_H__ */

